"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserFlowReportMock = exports.UserFlowMock = void 0;
const tslib_1 = require("tslib");
const loggin_1 = require("../../../../core/loggin");
const dummyFlowResult = (cfg) => {
    var _a, _b;
    const budgets = (_b = (_a = cfg === null || cfg === void 0 ? void 0 : cfg.config) === null || _a === void 0 ? void 0 : _a.settings) === null || _b === void 0 ? void 0 : _b.budgets;
    const report = {
        name: cfg.name,
        steps: [
            {
                name: 'Navigation report (127.0.0.1/)',
                lhr: {
                    configSettings: {
                    // "budgets": [] // budgets from configurations
                    },
                    audits: {
                    // "performance-budget": {},
                    // "timing-budget": {}
                    }
                }
            }
        ]
    };
    if (budgets) {
        report.steps[0].lhr.configSettings.budgets = budgets;
        report.steps[0].lhr.audits['performance-budget'] = {};
        report.steps[0].lhr.audits['timing-budget'] = {};
    }
    return report;
};
const dummyFlowReport = (cfg) => `
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8" />
<meta
  name="viewport"
  content="width=device-width, initial-scale=1, minimum-scale=1"
/>
<title>Lighthouse Flow Report</title>
<style></style>
<script>
${dummyFlowResult(cfg)}
</script>
</head>
<body></body>
`;
/**
 * @TODO this is very flakey ATM and needs investigation
 */
class UserFlowMock {
    /**
     * @param {LH.NavigationRequestor} requestor
     * @param {StepOptions=} stepOptions
     */
    navigate(requestor, { stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#navigate: ${stepName || requestor}`);
            return this.page.goto(requestor);
        });
    }
    constructor(page, cfg) {
        this.cfg = {};
        this.page = page;
        this.cfg = cfg;
    }
    /**
     * @param {StepOptions=} stepOptions
     */
    startTimespan({ stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#startTimespan: ${stepName}`);
            return Promise.resolve();
        });
    }
    endTimespan({ stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#endTimespan: ${stepName}`);
            return Promise.resolve();
        });
    }
    /**
     * @param {StepOptions=} stepOptions
     */
    snapshot({ stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#snapshot: ${stepName}`);
            return Promise.resolve();
        });
    }
    /**
     * @return {LH.FlowResult}
     */
    getFlowResult() {
        (0, loggin_1.logVerbose)(`flow#getFlowResult`);
        return dummyFlowResult(this.cfg);
    }
    createFlowResult() {
        (0, loggin_1.logVerbose)(`flow#getFlowResult`);
        return dummyFlowResult(this.cfg);
    }
    /**
     * @return {Promise<string>}
     */
    generateReport() {
        (0, loggin_1.logVerbose)(`flow#generateReport`);
        return Promise.resolve(dummyFlowReport(this.cfg));
    }
}
exports.UserFlowMock = UserFlowMock;
class UserFlowReportMock {
    /**
     * @param {LH.NavigationRequestor} requestor
     * @param {StepOptions=} stepOptions
     */
    navigate(requestor, { stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#navigate: ${stepName || requestor}`);
            return Promise.resolve();
        });
    }
    constructor(cfg) {
        this.cfg = {};
        this.cfg = cfg;
    }
    /**
     * @param {StepOptions=} stepOptions
     */
    startTimespan({ stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#startTimespan: ${stepName}`);
            return Promise.resolve();
        });
    }
    endTimespan({ stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#endTimespan: ${stepName}`);
            return Promise.resolve();
        });
    }
    /**
     * @param {StepOptions=} stepOptions
     */
    snapshot({ stepName } = {}) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#snapshot: ${stepName}`);
            return Promise.resolve();
        });
    }
    /**
     * @return {LH.FlowResult}
     */
    getFlowResult() {
        (0, loggin_1.logVerbose)(`flow#getFlowResult`);
        return dummyFlowResult(this.cfg);
    }
    createFlowResult() {
        (0, loggin_1.logVerbose)(`flow#getFlowResult`);
        return dummyFlowResult(this.cfg);
    }
    /**
     * @return {Promise<string>}
     */
    generateReport() {
        (0, loggin_1.logVerbose)(`flow#generateReport`);
        return Promise.resolve(dummyFlowReport(this.cfg));
    }
}
exports.UserFlowReportMock = UserFlowReportMock;
//# sourceMappingURL=user-flow.mock.js.map